# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, constr

from atriumsports.datacore.openapi.models.fixture_entities_model_entity import FixtureEntitiesModelEntity
from atriumsports.datacore.openapi.models.fixture_persons_model_person import FixturePersonsModelPerson
from atriumsports.datacore.openapi.models.fixture_progressions_model_fixture import FixtureProgressionsModelFixture
from atriumsports.datacore.openapi.models.game_log_person_model_organization import GameLogPersonModelOrganization


class GameLogPersonModel(BaseModel):
    """
    GameLogPersonModel
    """

    person_id: Optional[StrictStr] = Field(None, alias="personId", description="The unique identifier of the person")
    person: Optional[FixturePersonsModelPerson] = None
    organization_id: Optional[StrictStr] = Field(
        None, alias="organizationId", description="The unique identifier of the organization"
    )
    organization: Optional[GameLogPersonModelOrganization] = None
    fixture_id: Optional[StrictStr] = Field(None, alias="fixtureId", description="The unique identifier of the fixture")
    fixture: Optional[FixtureProgressionsModelFixture] = None
    entity_id: Optional[StrictStr] = Field(None, alias="entityId", description="The unique identifier of the entity")
    entity: Optional[FixtureEntitiesModelEntity] = None
    statistics: Optional[Dict[str, Any]] = None
    period_id: Optional[StrictInt] = Field(None, alias="periodId", description="The identifier for the period")
    section: Optional[constr(strict=True, max_length=100)] = Field(
        None, description="The section of the period (sub-period)"
    )
    bib: Optional[constr(strict=True, max_length=100)] = Field(None, description="The number displayed on the jersey")
    position: Optional[constr(strict=True, max_length=100)] = Field(None, description="Playing position")
    did_not_play_reason: Optional[constr(strict=True, max_length=100)] = Field(
        None, alias="didNotPlayReason", description="The reason the player didn't play"
    )
    starter: Optional[StrictBool] = None
    participated: Optional[StrictBool] = Field(
        None, description="Did the person actually participate in the the fixture"
    )
    is_player: Optional[StrictBool] = Field(None, alias="isPlayer", description="Is this person a player")
    is_team_official: Optional[StrictBool] = Field(
        None, alias="isTeamOfficial", description="Is this person an entity official"
    )
    updated: Optional[datetime] = Field(None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(None, description="Date/time added. In UTC")
    __properties = [
        "personId",
        "person",
        "organizationId",
        "organization",
        "fixtureId",
        "fixture",
        "entityId",
        "entity",
        "statistics",
        "periodId",
        "section",
        "bib",
        "position",
        "didNotPlayReason",
        "starter",
        "participated",
        "isPlayer",
        "isTeamOfficial",
        "updated",
        "added",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GameLogPersonModel:
        """Create an instance of GameLogPersonModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(
            by_alias=True,
            exclude={
                "organization_id",
                "updated",
                "added",
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of person
        if self.person:
            _dict["person"] = self.person.to_dict()
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of fixture
        if self.fixture:
            _dict["fixture"] = self.fixture.to_dict()
        # override the default output from pydantic by calling `to_dict()` of entity
        if self.entity:
            _dict["entity"] = self.entity.to_dict()
        # set to None if bib (nullable) is None
        # and __fields_set__ contains the field
        if self.bib is None and "bib" in self.__fields_set__:
            _dict["bib"] = None

        # set to None if position (nullable) is None
        # and __fields_set__ contains the field
        if self.position is None and "position" in self.__fields_set__:
            _dict["position"] = None

        # set to None if did_not_play_reason (nullable) is None
        # and __fields_set__ contains the field
        if self.did_not_play_reason is None and "did_not_play_reason" in self.__fields_set__:
            _dict["didNotPlayReason"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GameLogPersonModel:
        """Create an instance of GameLogPersonModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GameLogPersonModel.parse_obj(obj)

        _obj = GameLogPersonModel.parse_obj(
            {
                "person_id": obj.get("personId"),
                "person": FixturePersonsModelPerson.from_dict(obj.get("person"))
                if obj.get("person") is not None
                else None,
                "organization_id": obj.get("organizationId"),
                "organization": GameLogPersonModelOrganization.from_dict(obj.get("organization"))
                if obj.get("organization") is not None
                else None,
                "fixture_id": obj.get("fixtureId"),
                "fixture": FixtureProgressionsModelFixture.from_dict(obj.get("fixture"))
                if obj.get("fixture") is not None
                else None,
                "entity_id": obj.get("entityId"),
                "entity": FixtureEntitiesModelEntity.from_dict(obj.get("entity"))
                if obj.get("entity") is not None
                else None,
                "statistics": obj.get("statistics"),
                "period_id": obj.get("periodId"),
                "section": obj.get("section"),
                "bib": obj.get("bib"),
                "position": obj.get("position"),
                "did_not_play_reason": obj.get("didNotPlayReason"),
                "starter": obj.get("starter"),
                "participated": obj.get("participated"),
                "is_player": obj.get("isPlayer"),
                "is_team_official": obj.get("isTeamOfficial"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
