# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel, Field, StrictStr, validator


class HeadToHeadResolution(BaseModel):
    """
    HeadToHeadResolution
    """

    sort_field: Optional[StrictStr] = Field(None, alias="sortField", description="Sort Field")
    sort_direction: Optional[StrictStr] = Field(None, alias="sortDirection", description="Sort direction")
    __properties = ["sortField", "sortDirection"]

    @validator("sort_direction")
    def sort_direction_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("ASC", "DESC"):
            raise ValueError("must be one of enum values ('ASC', 'DESC')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HeadToHeadResolution:
        """Create an instance of HeadToHeadResolution from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HeadToHeadResolution:
        """Create an instance of HeadToHeadResolution from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HeadToHeadResolution.parse_obj(obj)

        _obj = HeadToHeadResolution.parse_obj(
            {"sort_field": obj.get("sortField"), "sort_direction": obj.get("sortDirection")}
        )
        return _obj
