# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel, Field, StrictStr


class PersonPostBodyAdditionalNamesValue(BaseModel):
    """
    The *property name* here can either be `default` (for a non-language specific name) or a two letter (lower-case) ISO 639-1 language code. eg `fr`, `es`
    """

    display: Optional[StrictStr] = None
    television: Optional[StrictStr] = Field(None, description="The name to be used on television")
    scoreboard: Optional[StrictStr] = Field(None, description="The name to be used on the scoreboard")
    pronunciation: Optional[StrictStr] = Field(None, description="The description of how to pronounce the name")
    boxscore: Optional[StrictStr] = None
    jersey: Optional[StrictStr] = None
    abbreviated: Optional[StrictStr] = None
    given: Optional[StrictStr] = None
    family: Optional[StrictStr] = None
    full: Optional[StrictStr] = None
    known_as: Optional[StrictStr] = Field(None, alias="knownAs")
    __properties = [
        "display",
        "television",
        "scoreboard",
        "pronunciation",
        "boxscore",
        "jersey",
        "abbreviated",
        "given",
        "family",
        "full",
        "knownAs",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PersonPostBodyAdditionalNamesValue:
        """Create an instance of PersonPostBodyAdditionalNamesValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if display (nullable) is None
        # and __fields_set__ contains the field
        if self.display is None and "display" in self.__fields_set__:
            _dict["display"] = None

        # set to None if television (nullable) is None
        # and __fields_set__ contains the field
        if self.television is None and "television" in self.__fields_set__:
            _dict["television"] = None

        # set to None if scoreboard (nullable) is None
        # and __fields_set__ contains the field
        if self.scoreboard is None and "scoreboard" in self.__fields_set__:
            _dict["scoreboard"] = None

        # set to None if pronunciation (nullable) is None
        # and __fields_set__ contains the field
        if self.pronunciation is None and "pronunciation" in self.__fields_set__:
            _dict["pronunciation"] = None

        # set to None if boxscore (nullable) is None
        # and __fields_set__ contains the field
        if self.boxscore is None and "boxscore" in self.__fields_set__:
            _dict["boxscore"] = None

        # set to None if jersey (nullable) is None
        # and __fields_set__ contains the field
        if self.jersey is None and "jersey" in self.__fields_set__:
            _dict["jersey"] = None

        # set to None if abbreviated (nullable) is None
        # and __fields_set__ contains the field
        if self.abbreviated is None and "abbreviated" in self.__fields_set__:
            _dict["abbreviated"] = None

        # set to None if given (nullable) is None
        # and __fields_set__ contains the field
        if self.given is None and "given" in self.__fields_set__:
            _dict["given"] = None

        # set to None if family (nullable) is None
        # and __fields_set__ contains the field
        if self.family is None and "family" in self.__fields_set__:
            _dict["family"] = None

        # set to None if full (nullable) is None
        # and __fields_set__ contains the field
        if self.full is None and "full" in self.__fields_set__:
            _dict["full"] = None

        # set to None if known_as (nullable) is None
        # and __fields_set__ contains the field
        if self.known_as is None and "known_as" in self.__fields_set__:
            _dict["knownAs"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PersonPostBodyAdditionalNamesValue:
        """Create an instance of PersonPostBodyAdditionalNamesValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PersonPostBodyAdditionalNamesValue.parse_obj(obj)

        _obj = PersonPostBodyAdditionalNamesValue.parse_obj(
            {
                "display": obj.get("display"),
                "television": obj.get("television"),
                "scoreboard": obj.get("scoreboard"),
                "pronunciation": obj.get("pronunciation"),
                "boxscore": obj.get("boxscore"),
                "jersey": obj.get("jersey"),
                "abbreviated": obj.get("abbreviated"),
                "given": obj.get("given"),
                "family": obj.get("family"),
                "full": obj.get("full"),
                "known_as": obj.get("knownAs"),
            }
        )
        return _obj
